// T10simCont.sce
// STEP RESPONSE OF THE FIRST ORDER REGRESSION MODEL
// Experiments
// - change parameters of the model
// - try to increase the model order to 3 (EXERCISE)
// -------------------------------------------------------------------
exec("ScIntro.sce",-1)

// PARAMETERS OF THE SIMULATION
nd=100;                       // length of data
a=[-.9];                       // parameters at yt
b=[1 0];                      // parameters at ut
k=0;                          // constant (model absolute term)
s=.000001;                    // noise variance

yt(1)=0;                     // initial conditions for output
ut=ones(1,nd);                // input (all ones)

// TIME LOOP OF THE SIMULATION
th=[a b k]';                  // vector of parameters
for t=2:nd
  // regression vector
  ps=[yt(t-1) ut(t) ut(t-1) 1]';
  // regression model
  yt(t)=th'*ps+s*rand(1,1,'norm'); 
end

// RESULTS OF THE SIMULATION
set(gcf(),"position",[700 100 600 500])
plot(1:nd,yt),title('Output')

/*
y = a*y
