// T11simCont.sce
// STEP RESPONSE OF THE SECOND ORDER REGRESSION MODEL
// Experiments
// - change parameters of the model
// - change the input signal
// - try to increase the model order to 3
// -------------------------------------------------------------------
exec("ScIntro.sce",-1)
mode(0)

nd=50;                       // length of data
// roots of the characteristics equation
r=[.7+.8*%i];                    // re: [.9 .2]; doub: [.4 .4];  comp: [.2+.5*%i]

if length(r)==1
  a1=2*real(r);
  a2=-r*conj(r);
  disp(' distance of root from (0,0)')
  m=sqrt(r*conj(r))
else
  a1=r(1)+r(2);
  a2=-r(1)*r(2);
end

disp('  a=[a1, a2] ->  y(t)=a1.y(t-1)+a2.y(t-2)');
a=[a1 a2]                     // parameters at yt
b=[1 0 0];                    // parameters at ut
k=0;                          // constant (model absolute term)
s=.000001;                    // noise variance

yt(1)=0; yt(2)=0;            // initial conditions for output
ut=1*ones(1,nd);              // input

// TIME LOOP OF THE SIMULATION
th=[a b k]';                  // vector of parameters
for t=3:nd
  // regression vector
  ps=[yt(t-1) yt(t-2) ut(t) ut(t-1) ut(t-2) 1]';
  // regression model
  yt(t)=th'*ps+s*rand(1,1,'norm'); 
end

// RESULTS OF THE SIMULATION
set(gcf(),"position",[700 100 600 500])
plot(1:nd,yt,'.:'),title('Output')
