// T22estCont_B4.sce
// ESTIMATION OF 2ND ORDER REGRESSION MODEL
// Estimation with REAL DATA (intensities of traffic in Strahov tunnel)
// i.e. MODEL STRUCTURE MISMATCH is tackled.
// - Bayesian on-line estimation with statistic update
// - cannot be done without estimation !!!
// Experiments 
// - change the order of model for estimation
// Result: estimated parameters (better with prediction - T32preCont_Adapt3.sce)
// -------------------------------------------------------------------
exec("ScIntro.sce",-1), mode(0)

ord=5;                        // order of the estimated model
// selection of dataset
k=3;                          // selected day
nz=50;                        // beginning of the day
nd=288;                       // length of the whole one day data

// DATA
dtAll=csvRead('STRAHOV.csv',';');
dt=dtAll((k-1)*288+(nz+1:nd),1);
yt=dt(:,1);

// ESTIMATION
nth=ord+2;
V=1e-8*eye(nth,nth);              // initial information matrix
for t=(ord+1):(nd-nz)
  psi=[yt(t:-1:t-ord); 1];// reg. vector
  V=V+psi*psi';                              // updt of information matrix
  Vy=V(1,1); Vyp=V(2:$,1); Vp=V(2:$,2:$);    // divisioning of inf. matrix
  thE(:,t)=inv(Vp+1e-8*eye(Vp))*Vyp;         // pt estimates of reg. coefficints
  r(t)=(Vy-Vyp'*inv(Vp+1e-8*eye(Vp))*Vyp)/t; // pt estimates of noise variance
end


for t=(ord+1):(nd-nz)
  ps=[yt(t-1:-1:t-ord); 1];
  yp(t)=ps'*thE(:,t);
end
SE=rpe(yt,yp,nd)

set(scf(3),'position',[50 360 400 200])
plot(1:nd-nz,yt,1:nd-nz,yp)
legend('output','prediction');

// Results
set(scf(1),'position',[500 60 600 500])
for i=1:nth-1
  subplot(nth,1,i),plot(thE(i,:))
  if i==1, title('Regression coefficients'), end
end
set(scf(2),'position',[50 60 400 200])
plot(r)
title('Noise variance')
set(scf(3),'position',[50 360 400 200])
plot(1:nd-nz,yt)
legend('output');
title 'Dataset for estimation'

disp(thE(:,$)','Easimated parameters')
